module dual_core_array_synthwrapper
  (
    // Outputs
    out_ready, out_result, out_valid,
    // Inputs
    clk, reset_n, inp_request, inp_valid, inp_ready, in_init_load, in_init_addr, in_init_data_yo
  );


  import types_pkg::*;

  parameter NUM_DCORES = 16;


  // Control
  input  logic                                reset_n;
  input  logic                                clk;

  // Request interface
  input  logic [REQUEST_BITS            -1:0] inp_request;
  input  logic                                inp_valid;
  output logic                                out_ready;

  // Result interface
  output logic [RESULT_BITS             -1:0] out_result;
  output logic                                out_valid;
  input  logic                                inp_ready;

  // Object buffer input initialisation
  input  logic                                in_init_load;
  input  logic [OBJ_BUFFER_ADDR_BITS    -1:0] in_init_addr;
  input  logic [WORD_BITS/2             -1:0] in_init_data_yo;

  // Debug interface
  integer                                     active_threads;

  // Hackish solution to lack of IO on FPGA
  logic [WORD_BITS               -1:0] in_init_data;
  assign in_init_data = {in_init_data_yo, in_init_data_yo};

  dual_core_array #(
    .NUM_DCORES(NUM_DCORES)
  ) U0 (
    .*
  );
endmodule