module instruction_memory
  (
    // Outputs
    c0_instruction, c1_instruction,
    // Inputs
    clk, c0_instruction_address, c1_instruction_address
  );

  import types_pkg::*;

  // Control
  // input  logic                                reset_n;
  input  logic                                clk;

  // Inputs
  input  logic [PC_BITS                 -1:0] c0_instruction_address;
  input  logic [PC_BITS                 -1:0] c1_instruction_address;

  // Outputs
  output instruction_union_t                  c0_instruction;
  output instruction_union_t                  c1_instruction;

  // Internal signals
  reg [INSTRUCTION_BITS -1:0] rom [0:2**PC_BITS -1];


  // Synthesisable construct for Xilinx FPGAs
  initial begin
    $readmemb("instruction_memory.dat", rom);
  end


  always_ff @(posedge clk) begin
    c0_instruction <= rom[c0_instruction_address];
    c1_instruction <= rom[c1_instruction_address];
  end

endmodule