import struct
import numpy as np


def as_int(a):
    return np.int32(struct.unpack('<l', struct.pack('<f', a))[0])

# print('wire [7:0] fxnum;')
# print('reg [31:0] fpnum;')
# print('always @* begin')
# print('  case ( fxnum )')
for i, fp in enumerate(np.linspace(0, 1, 256)):
    print("{:7f} : {:032b} -> {}".format(fp, as_int(fp), i))

print('')
print('-'*60)
print('')


# Using FPU to add 1.0f (could come from immediate field of instruction, or hard coded). (1.0f = 0x3f800000)
# The integer representation is then directly taken by a bit slice. Overflow is detected and 'corrected' for.
for i in range(0,256+10):
    fp = i*2**-8 + 1
    asint = as_int(fp)
    intified = (asint >> 15) & 0xFF
    overflowing = (asint >> 23) != 0b001111111

    final_value = intified if not overflowing else 255

    print("{:11.7f} : {:032b} -> {:3d} {:3d} {:1} -> {:3d} (cheating: {:3d})".format(fp, asint, i, intified, overflowing, final_value, int((fp-1)*256)))
