import struct
import numpy as np


def as_int(a):
    return np.int32(struct.unpack('<l', struct.pack('<f', a))[0])

print('wire [7:0] fxnum;')
print('reg [31:0] fpnum;')
print('always @* begin')
print('  case ( fxnum )')
for fx in range(0, 128 + 1):
    fp = fx * 2**-7
    print("    8'b{:08b}: fpnum = 32'b{:032b}; // {}".format(fx, as_int(fp), fp))

print('')
print(
    "        default: fpnum = 32'b{:032b}; // {} (clamping to max legal value)".format(as_int(fp), fp))
print('  endcase')
print('end')
