# ------------------------------------------------------------------------------
# Author       : Oystein Gjermundnes
# Organization : Norwegian University of Science and Technology (NTNU)
#                http://www.iet.ntnu.no/en
# Course       : Design of digital systems 1 (DDS1)
# Year         : 2015
# Fork         : git clone git@bitbucket.org:oysteingjermundnes/dds1.git
# Description  : Raytracer model written in python
# License      : This is free and unencumbered software released into the 
#                public domain (UNLICENSE)
# ------------------------------------------------------------------------------

from rayman.vector import *

################################################################################
## Intersection point
#
# The purpose of this class is to identify the intersection point between a
# ray and a surface. In addition to the coordinates of the intersection point
#
# @param self Pointer to the object.
################################################################################
class IsectPoint:
  ##############################################################################
  ## Constructor
  #
  # @param self Pointer to the object.
  ##############################################################################
  def __init__(self):
    ## Intersection point coordinates of vector.Vector type
    self.coord  = Vector(0,0,0)    
    ## Normal at the intersection point of vector.Vector type
    self.normal = Vector(0,0,0)   
    ## Parametric distance between origin and intersection point.
    self.t      = np.float32(0.0)  # This is ONLY used by find_closest_intersection()......
    ## Pointer to the surface where the intersection point is                               
    self.surface = 0
