module object_buffer_tb
  (
  );

  import types_pkg::*;

  // Control
  logic                                reset_n;
  logic                                clk;

  // Input initialisation
  logic                                in_init_load;
  logic [OBJ_BUFFER_ADDR_BITS    -1:0] in_init_addr;
  logic [WORD_BITS               -1:0] in_init_data;

  // Output initialisation
  logic                                out_init_load;
  logic [OBJ_BUFFER_ADDR_BITS    -1:0] out_init_addr;
  logic [WORD_BITS               -1:0] out_init_data;

  // Core 0 interface
  logic [OBJ_BUFFER_ADDR_BITS    -1:0] c0_obj_addr;
  logic [WORD_BITS               -1:0] c0_obj_data;

  // Core 1 interface
  logic [OBJ_BUFFER_ADDR_BITS    -1:0] c1_obj_addr;
  logic [WORD_BITS               -1:0] c1_obj_data;


  object_buffer U1 (
    .clk(clk),
    .in_init_load(out_init_load),
    .in_init_addr(out_init_addr),
    .in_init_data(out_init_data),
    .c0_obj_addr(c0_obj_addr),
    .c1_obj_addr(c1_obj_addr)

  );

  initial begin
    clk = 0;
    reset_n = 0;
    #4 reset_n = 1;
  end;

  initial begin
    c0_obj_addr = 3;
    c1_obj_addr = 6;
  end

  always  
    #1 clk = ~clk;

  assign in_init_data = in_init_addr;
  assign in_init_load = in_init_addr[1];
  always_ff @(posedge clk) begin
    if ( !reset_n ) begin
      in_init_addr <= 0;
    end
    else begin
      in_init_addr <= in_init_addr + 1;
    end
  end

endmodule

