module ray_core_property
  (
    // Outputs
    out_ready, out_result, out_valid, out_obj_read, out_obj_addr,
    // Inputs
    clk, reset_n, inp_request, inp_valid, inp_ready, inp_obj_data
  );

  import types_pkg::*;


  // Control
  input  logic                                reset_n;
  input  logic                                clk;

  // Inputs
  input  logic [REQUEST_BITS            -1:0] inp_request;
  input  logic                                inp_valid;
  input  logic                                inp_ready;
  input  logic [WORD_BITS               -1:0] inp_obj_data;

  // Outputs
  input  logic [RESULT_BITS             -1:0] out_result;
  input  logic                                out_valid;
  input  logic                                out_ready;
  input  logic [OBJ_BUFFER_ADDR_BITS    -1:0] out_obj_addr;
  input  logic                                out_obj_read;

  property request_stable;
    @(posedge clk) (inp_valid & !out_ready) |=> $stable(inp_request);
  endproperty
  assert property (request_stable) else $display($stime,,,"request_stable FAIL");

  property result_stable;
    @(posedge clk) out_valid |=> $stable(out_result);
  endproperty
  assert property (result_stable) else $display($stime,,,"result_stable FAIL");


endmodule
