from io import BytesIO, StringIO
from PIL import Image


# Python 3 compatibility hack
try:
    unicode('')
except NameError:
    unicode = str


h = 480
w = 640


def get_image(filename):
    img = Image.new('RGB', (w, h), 'pink')
    pixels = img.load()

    with open(filename) as fh:
        for line in fh.readlines():
            if (line.startswith('//')) or (not line):
                continue
            line = line.replace('_', '')
            s = StringIO(unicode(line))

            frame_id = int(s.read(1), 2)
            x = int(s.read(10), 2)
            y = int(s.read(9), 2)

            r = int(s.read(8), 2)
            g = int(s.read(8), 2)
            b = int(s.read(8), 2)

            pixels[x, y] = (r, g, b)
    return img

img_calc = get_image('responses_calc.dat')
img_pymo = get_image('responses.dat')

img_calc.show()
img_calc.save('responses_calc.png')
img_pymo.show()
img_pymo.save('responses.png')

allequal = True
for x in range(w):
    for y in range(h):
        if img_calc.getpixel((x, y)) != img_pymo.getpixel((x, y)):
            print('({}, {}) is not the same in both images'.format(x, y))
            allequal = False

if allequal:
    print('All pixels are equal')
